VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "classTabella"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type tMatrice
    Colore As Integer
    Segno As Integer
End Type

Private Matrice(0 To 17, 0 To 17) As tMatrice

Private Sub Disegna(i As Integer, j As Integer)
    
    Dim X, Y As Integer
    
    Y = (j * 16) * Screen.TwipsPerPixelX
    X = (i * 32 + 16 * ((j + 1) Mod 2)) * Screen.TwipsPerPixelY
    frm7Colors.ImageList1.ListImages(Matrice(i, j).Colore + 7 * gConfig.BlockStyle + 1).Draw frm7Colors.picContenitore.hDC, X, Y, imlTransparent
    
End Sub

Public Property Get PlayerCol(Index As Integer) As Integer

    If Index = 0 Then
        PlayerCol = Matrice(0, 17).Colore
    Else
        PlayerCol = Matrice(17, 0).Colore
    End If

End Property

Public Function ColoraGiocatore(Giocatore As Integer, Colore As Integer) As Single

    Dim NumCaselle As Integer

    If Giocatore = 0 Then
        CancellaSegni
        NumCaselle = CambiaVecchioColore(0, 17, PlayerCol(0), Colore)
        RiempiAreaEsterna 17, 0
        NumCaselle = NumCaselle + RiempiBuchi(Colore)
    Else
        CancellaSegni
        NumCaselle = CambiaVecchioColore(17, 0, PlayerCol(1), Colore)
        RiempiAreaEsterna 0, 17
        NumCaselle = NumCaselle + RiempiBuchi(Colore)
    End If
    ColoraGiocatore = NumCaselle * 100 / (18 * 18)
    
End Function

Public Sub Randomizza()

    Dim i As Integer
    Dim j As Integer
        
    For j = 0 To 17
        For i = 0 To 17
            Colora i, j, Int(Rnd * 7)
        Next
    Next
    
    If Matrice(0, 17).Colore = Matrice(17, 0).Colore Then
        Colora 0, 17, (Matrice(17, 0).Colore + 1) Mod 7
    End If
    
End Sub

Private Sub Colora(i As Integer, j As Integer, Colore As Integer)
    
    Matrice(i, j).Colore = Colore
    Disegna i, j

End Sub

Private Function CambiaVecchioColore(ByVal X As Integer, ByVal Y As Integer, ByVal VecchioColore As Integer, ByVal NuovoColore As Integer) As Integer

    Dim k As Integer
    
    k = 0
    If X < 18 And X >= 0 And Y < 18 And Y >= 0 Then
        If Matrice(X, Y).Colore = VecchioColore Then
            Colora X, Y, NuovoColore
            Matrice(X, Y).Segno = 1
            If Y Mod 2 = 0 Then
                k = CambiaVecchioColore(X, Y - 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X, Y + 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X + 1, Y - 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X + 1, Y + 1, VecchioColore, NuovoColore) _
                + 1
            Else
                k = CambiaVecchioColore(X, Y - 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X, Y + 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X - 1, Y - 1, VecchioColore, NuovoColore) _
                + CambiaVecchioColore(X - 1, Y + 1, VecchioColore, NuovoColore) _
                + 1
            End If
        Else
            If Matrice(X, Y).Colore = NuovoColore And Matrice(X, Y).Segno = 0 Then
                Matrice(X, Y).Segno = 1
                If Y Mod 2 = 0 Then
                    k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                    + AnnettiNuovoColore(X + 1, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X + 1, Y + 1, NuovoColore) _
                    + 1
                Else
                    k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                    + AnnettiNuovoColore(X - 1, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X - 1, Y + 1, NuovoColore) _
                    + 1
                End If
            End If
        End If
    End If
    CambiaVecchioColore = k
    
End Function

Private Function AnnettiNuovoColore(ByVal X As Integer, ByVal Y As Integer, ByVal NuovoColore As Integer) As Integer
    
    Dim k As Integer
    
    k = 0
    If X < 18 And X >= 0 And Y < 18 And Y >= 0 Then
        If Matrice(X, Y).Colore = NuovoColore And Matrice(X, Y).Segno = 0 Then
            Matrice(X, Y).Segno = 1
            If Y Mod 2 = 0 Then
                k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                + AnnettiNuovoColore(X + 1, Y - 1, NuovoColore) _
                + AnnettiNuovoColore(X + 1, Y + 1, NuovoColore) _
                + 1
            Else
                k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                + AnnettiNuovoColore(X - 1, Y - 1, NuovoColore) _
                + AnnettiNuovoColore(X - 1, Y + 1, NuovoColore) _
                + 1
            End If
        End If
    End If
    AnnettiNuovoColore = k
        
End Function

Private Sub CancellaSegni()
    
    Dim i As Integer
    Dim j As Integer
        
    For j = 0 To 17
        For i = 0 To 17
            Matrice(i, j).Segno = 0
        Next
    Next

End Sub

Private Sub RiempiAreaEsterna(ByVal X As Integer, ByVal Y As Integer)

    If X < 18 And X >= 0 And Y < 18 And Y >= 0 Then
        If Matrice(X, Y).Segno = 0 Then
            Matrice(X, Y).Segno = 1
            If Y Mod 2 = 0 Then
                RiempiAreaEsterna X, Y - 1
                RiempiAreaEsterna X, Y + 1
                RiempiAreaEsterna X + 1, Y - 1
                RiempiAreaEsterna X + 1, Y + 1
            Else
                RiempiAreaEsterna X, Y - 1
                RiempiAreaEsterna X, Y + 1
                RiempiAreaEsterna X - 1, Y - 1
                RiempiAreaEsterna X - 1, Y + 1
            End If
        End If
    End If

End Sub

Private Function RiempiBuchi(ByVal Colore As Integer) As Integer
    
    Dim k As Integer
    Dim i As Integer
    Dim j As Integer
    
    k = 0
    For j = 0 To 17
        For i = 0 To 17
            If Matrice(i, j).Segno = 0 Then
                Colora i, j, Colore
                k = k + 1
            End If
        Next
    Next
    RiempiBuchi = k

End Function

Public Function GetPercent(Giocatore As Integer) As Single

    Dim NumCaselle As Integer

    If Giocatore = 0 Then
        CancellaSegni
        NumCaselle = AnnettiNuovoColore(0, 17, PlayerCol(0))
    Else
        CancellaSegni
        NumCaselle = AnnettiNuovoColore(17, 0, PlayerCol(1))
    End If
    GetPercent = NumCaselle * 100 / (18 * 18)

End Function

Public Sub Ridisegna()

    Dim i As Integer
    Dim j As Integer
        
    For j = 0 To 17
        For i = 0 To 17
            Disegna i, j
        Next
    Next

End Sub

Public Function GuadagnoMax(Giocatore As Integer) As Integer

    Dim i As Integer
    Dim iMax As Integer
    Dim c As Integer
    Dim cMax As Integer
    
    For i = 0 To 6
        If i <> PlayerCol(0) And i <> PlayerCol(1) Then
            CancellaSegni
            If Giocatore = 0 Then
                c = Guadagno(0, 17, PlayerCol(0), i)
            Else
                c = Guadagno(17, 0, PlayerCol(1), i)
            End If
            If c >= cMax Then
                cMax = c
                iMax = i
            End If
        End If
    Next
    
    GuadagnoMax = iMax
    
End Function


Private Function Guadagno(ByVal X As Integer, ByVal Y As Integer, ByVal VecchioColore As Integer, ByVal NuovoColore As Integer) As Integer

    Dim k As Integer
    
    k = 0
    If X < 18 And X >= 0 And Y < 18 And Y >= 0 Then
        If Matrice(X, Y).Colore = VecchioColore And Matrice(X, Y).Segno = 0 Then
            Matrice(X, Y).Segno = 1
            If Y Mod 2 = 0 Then
                k = Guadagno(X, Y - 1, VecchioColore, NuovoColore) _
                + Guadagno(X, Y + 1, VecchioColore, NuovoColore) _
                + Guadagno(X + 1, Y - 1, VecchioColore, NuovoColore) _
                + Guadagno(X + 1, Y + 1, VecchioColore, NuovoColore) _
                + 1
            Else
                k = Guadagno(X, Y - 1, VecchioColore, NuovoColore) _
                + Guadagno(X, Y + 1, VecchioColore, NuovoColore) _
                + Guadagno(X - 1, Y - 1, VecchioColore, NuovoColore) _
                + Guadagno(X - 1, Y + 1, VecchioColore, NuovoColore) _
                + 1
            End If
        Else
            If Matrice(X, Y).Colore = NuovoColore And Matrice(X, Y).Segno = 0 Then
                Matrice(X, Y).Segno = 1
                If Y Mod 2 = 0 Then
                    k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                    + AnnettiNuovoColore(X + 1, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X + 1, Y + 1, NuovoColore) _
                    + 1
                Else
                    k = AnnettiNuovoColore(X, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X, Y + 1, NuovoColore) _
                    + AnnettiNuovoColore(X - 1, Y - 1, NuovoColore) _
                    + AnnettiNuovoColore(X - 1, Y + 1, NuovoColore) _
                    + 1
                End If
            End If
        End If
    End If
    Guadagno = k
    
End Function


